Signal/Geometry Processing Library (SPL) 1.1.24 |

Classes | Functions
Binary and m-ary Arithmetic Coders
Arithmetic Coders

Binary and m-ary arithmetic coders. More...

## Classes
class | SPL::MultiArithEncoder
| M-ary arithmetic encoder class. More...
class | SPL::MultiArithDecoder
| M-ary arithmetic decoder class. More...
struct | SPL::BinArithCoderContextStat
| Binary Arithmetic Coder Context Statistics Class. More...
class | SPL::BinArithEncoder
| Binary arithmetic encoder class. More...
class | SPL::BinArithDecoder
| Binary arithmetic decoder class. More...

## Functions
static std::ostream & | SPL::MultiArithEncoder::getDebugStream ()
| Get the stream for debugging output. More...
OutputBitStream * | SPL::MultiArithEncoder::getOutput ()
| Get the bit stream used for output. More...
void | SPL::MultiArithEncoder::setOutput (OutputBitStream *out)
| Set the bit stream used for output. More...
SPL_ArithCoder_ulong | SPL::MultiArithEncoder::getSymCount () const
| Get the number of symbols encoded so far. More...
SPL_ArithCoder_ulong | SPL::MultiArithEncoder::getBitCount () const
| Get the number of bits of output generated so far including bits awaiting output. More...
static void | SPL::MultiArithEncoder::setDebugLevel (int debugLevel)
| Set the debug level. More...
static void | SPL::MultiArithEncoder::setDebugStream (std::ostream &out)
| Set the stream for debugging output. More...
int | SPL::MultiArithEncoder::getMaxContexts () const
| Get the maximum number of contexts. More...
static std::ostream & | SPL::MultiArithDecoder::getDebugStream ()
| Get the stream used for debugging output. More...
InputBitStream * | SPL::MultiArithDecoder::getInput () const
| Get the bit stream from which to read encoded data. More...
void | SPL::MultiArithDecoder::setInput (InputBitStream *in)
| Set the bit stream from which to read encoded data. More...
SPL_ArithCoder_ulong | SPL::MultiArithDecoder::getBitCount () const
| Get the number of bits read so far. More...
SPL_ArithCoder_ulong | SPL::MultiArithDecoder::getSymCount () const
| Get the number of symbols decoded so far. More...
static void | SPL::MultiArithDecoder::setDebugLevel (int debugLevel)
| Set the debug level. More...
static void | SPL::MultiArithDecoder::setDebugStream (std::ostream &out)
| Set the stream to use for debugging output. More...
int | SPL::MultiArithDecoder::getMaxContexts () const
| Get the maximum number of contexts. More...
SPL_ArithCoder_ulong | SPL::BinArithEncoder::getSymCount () const
| Get the number of symbols output so far. More...
SPL_ArithCoder_ulong | SPL::BinArithEncoder::getBitCount () const
| Get the number of bits output so far. More...
OutputBitStream * | SPL::BinArithEncoder::getOutput () const
| Get the bit stream to which encoded data should be written. More...
int | SPL::BinArithEncoder::getNumContexts () const
| Get the number of contexts. More...
static void | SPL::BinArithEncoder::setDebugStream (std::ostream &out)
| Set the stream to use for debugging output. More...
static std::ostream & | SPL::BinArithEncoder::getDebugStream ()
| Get the stream used for debugging output. More...
static void | SPL::BinArithEncoder::setDebugLevel (int debugLevel)
| Set the debug level. More...
void | SPL::BinArithEncoder::setOutput (OutputBitStream *out)
| Set the bit stream to which encoded data should be written. More...
SPL_ArithCoder_ulong | SPL::BinArithDecoder::getSymCount () const
| Get the number of symbols decoded so far. More...
SPL_ArithCoder_ulong | SPL::BinArithDecoder::getBitCount () const
| Get the number of bits read so far. More...
InputBitStream * | SPL::BinArithDecoder::getInput () const
| Get the bit stream from which to read encoded data. More...
int | SPL::BinArithDecoder::getNumContexts () const
| Get the number of contexts. More...
static void | SPL::BinArithDecoder::setDebugStream (std::ostream &out)
| Set the stream to be used for debugging output. More...
static std::ostream & | SPL::BinArithDecoder::getDebugStream ()
| Get the stream used for debugging output. More...
static void | SPL::BinArithDecoder::setDebugLevel (int debugLevel)
| Set the debug level. More...
void | SPL::BinArithDecoder::setInput (InputBitStream *in)
| Set the bit stream from which to read encoded data. More...

## Detailed Description

Binary and m-ary arithmetic coders.

## Function Documentation

SPL_ArithCoder_ulong SPL::MultiArithEncoder::getBitCount | ( |  | ) | const
| inline

Get the number of bits of output generated so far including bits awaiting output.

SPL_ArithCoder_ulong SPL::MultiArithDecoder::getBitCount | ( |  | ) | const
| inline

Get the number of bits read so far.

SPL_ArithCoder_ulong SPL::BinArithEncoder::getBitCount | ( |  | ) | const
| inline

Get the number of bits output so far.

This function gets the number of bits output so far by the arithmetic encoder.

Returns
  The number of bits output so far is returned.

SPL_ArithCoder_ulong SPL::BinArithDecoder::getBitCount | ( |  | ) | const
| inline

Get the number of bits read so far.

This function gets the number of bits read so far by the arithmetic decoder.

Returns
  The number of bits read so far is returned.

std::ostream & SPL::MultiArithEncoder::getDebugStream | ( |  | ) |
| inline static

Get the stream for debugging output.

std::ostream & SPL::MultiArithDecoder::getDebugStream | ( |  | ) |
| inline static

Get the stream used for debugging output.

std::ostream & SPL::BinArithEncoder::getDebugStream | ( |  | ) |
| inline static

Get the stream used for debugging output.

std::ostream & SPL::BinArithDecoder::getDebugStream | ( |  | ) |
| inline static

Get the stream used for debugging output.

InputBitStream * SPL::MultiArithDecoder::getInput | ( |  | ) | const
| inline

Get the bit stream from which to read encoded data.

InputBitStream * SPL::BinArithDecoder::getInput | ( |  | ) | const
| inline

Get the bit stream from which to read encoded data.

This function gets the bit stream from which to read encoded data.

Returns
  A pointer to the bit stream is returned.

int SPL::MultiArithEncoder::getMaxContexts | ( |  | ) | const
| inline

Get the maximum number of contexts.

int SPL::MultiArithDecoder::getMaxContexts | ( |  | ) | const
| inline

Get the maximum number of contexts.

int SPL::BinArithEncoder::getNumContexts | ( |  | ) | const
| inline

Get the number of contexts.

This function gets the number of contexts employed by the arithmetic encoder.

Returns
  The number of contexts is returned.

int SPL::BinArithDecoder::getNumContexts | ( |  | ) | const
| inline

Get the number of contexts.

This function gets the number of contexts employed by the arithmetic decoder.

Returns
  The number of contexts is returned.

OutputBitStream * SPL::MultiArithEncoder::getOutput | ( |  | ) |
| inline

Get the bit stream used for output.

OutputBitStream * SPL::BinArithEncoder::getOutput | ( |  | ) | const
| inline

Get the bit stream to which encoded data should be written.

This function gets the bit stream to which encoded data should be written.

Returns
  A pointer to the output bit stream is returned.

SPL_ArithCoder_ulong SPL::MultiArithEncoder::getSymCount | ( |  | ) | const
| inline

Get the number of symbols encoded so far.

SPL_ArithCoder_ulong SPL::MultiArithDecoder::getSymCount | ( |  | ) | const
| inline

Get the number of symbols decoded so far.

SPL_ArithCoder_ulong SPL::BinArithEncoder::getSymCount | ( |  | ) | const
| inline

Get the number of symbols output so far.

This function gets the number of symbols output so far by the arithmetic encoder.

Returns
  The number of symbols output so far is returned.

SPL_ArithCoder_ulong SPL::BinArithDecoder::getSymCount | ( |  | ) | const
| inline

Get the number of symbols decoded so far.

This function gets the number of symbols decoded so far by the arithmetic decoder.

Returns
  The number of symbols decoded so far is returned.

void SPL::MultiArithEncoder::setDebugLevel | ( | int | debugLevel | ) |
| inline static

Set the debug level.

void SPL::MultiArithDecoder::setDebugLevel | ( | int | debugLevel | ) |
| inline static

Set the debug level.

void SPL::BinArithEncoder::setDebugLevel | ( | int | debugLevel | ) |
| inline static

Set the debug level.

void SPL::BinArithDecoder::setDebugLevel | ( | int | debugLevel | ) |
| inline static

Set the debug level.

void SPL::MultiArithEncoder::setDebugStream | ( | std::ostream & | out | ) |
| inline static

Set the stream for debugging output.

void SPL::MultiArithDecoder::setDebugStream | ( | std::ostream & | out | ) |
| inline static

Set the stream to use for debugging output.

void SPL::BinArithEncoder::setDebugStream | ( | std::ostream & | out | ) |
| inline static

Set the stream to use for debugging output.

void SPL::BinArithDecoder::setDebugStream | ( | std::ostream & | out | ) |
| inline static

Set the stream to be used for debugging output.

void SPL::MultiArithDecoder::setInput | ( | InputBitStream * | in | ) |
| inline

Set the bit stream from which to read encoded data.

void SPL::BinArithDecoder::setInput | ( | InputBitStream * | in | ) |
| inline

Set the bit stream from which to read encoded data.

Parameters

  in | The input bit stream.

This function sets the bit stream from which to read encoded data to `in`.

void SPL::MultiArithEncoder::setOutput | ( | OutputBitStream * | out | ) |
| inline

Set the bit stream used for output.

void SPL::BinArithEncoder::setOutput | ( | OutputBitStream * | out | ) |
| inline

Set the bit stream to which encoded data should be written.

Parameters

  out | The output bit stream.

This function sets the bit stream to which encoded data should be written.